    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------------
    028     * SeriesRenderingOrder.java
    029     * --------------------------
    030     * (C) Copyright 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  Eric Thomas (www.isti.com);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 21-Apr-2005 : Version 1 contributed by Eric Thomas (ET);
    038     *
    039     */
    040
    041    package org.jfree.chart.plot;
    042
    043    import java.io.ObjectStreamException;
    044    import java.io.Serializable;
    045
    046    /**
    047     * Defines the tokens that indicate the rendering order for series in a
    048     * {@link org.jfree.chart.plot.XYPlot}.
    049     */
    050    public final class SeriesRenderingOrder implements Serializable {
    051
    052        /** For serialization. */
    053        private static final long serialVersionUID = 209336477448807735L;
    054
    055        /**
    056         * Render series in the order 0, 1, 2, ..., N-1, where N is the number
    057         * of series.
    058         */
    059        public static final SeriesRenderingOrder FORWARD
    060            = new SeriesRenderingOrder("SeriesRenderingOrder.FORWARD");
    061
    062        /**
    063         * Render series in the order N-1, N-2, ..., 2, 1, 0, where N is the
    064         * number of series.
    065         */
    066        public static final SeriesRenderingOrder REVERSE
    067            = new SeriesRenderingOrder("SeriesRenderingOrder.REVERSE");
    068
    069        /** The name. */
    070        private String name;
    071
    072        /**
    073         * Private constructor.
    074         *
    075         * @param name  the name.
    076         */
    077        private SeriesRenderingOrder(String name) {
    078            this.name = name;
    079        }
    080
    081        /**
    082         * Returns a string representing the object.
    083         *
    084         * @return The string (never <code>null</code>).
    085         */
    086        public String toString() {
    087            return this.name;
    088        }
    089
    090        /**
    091         * Returns <code>true</code> if this object is equal to the specified
    092         * object, and <code>false</code> otherwise.
    093         *
    094         * @param obj  the other object.
    095         *
    096         * @return A boolean.
    097         */
    098        public boolean equals(Object obj) {
    099
    100            if (this == obj) {
    101                return true;
    102            }
    103            if (!(obj instanceof SeriesRenderingOrder)) {
    104                return false;
    105            }
    106
    107            SeriesRenderingOrder order = (SeriesRenderingOrder) obj;
    108            if (!this.name.equals(order.toString())) {
    109                return false;
    110            }
    111
    112            return true;
    113
    114        }
    115
    116        /**
    117         * Ensures that serialization returns the unique instances.
    118         *
    119         * @return The object.
    120         *
    121         * @throws ObjectStreamException if there is a problem.
    122         */
    123        private Object readResolve() throws ObjectStreamException {
    124            if (this.equals(SeriesRenderingOrder.FORWARD)) {
    125                return SeriesRenderingOrder.FORWARD;
    126            }
    127            else if (this.equals(SeriesRenderingOrder.REVERSE)) {
    128                return SeriesRenderingOrder.REVERSE;
    129            }
    130            return null;
    131        }
    132
    133    }